diff --git a/lib/info.c b/lib/info.c
index 3d46678..c800428 100644
--- a/lib/info.c
+++ b/lib/info.c
@@ -601,15 +601,25 @@ int vorbis_analysis_headerout(vorbis_dsp_state *v,
   oggpack_reset(&opb);
   if(_vorbis_pack_comment(&opb,vc))goto err_out;
 
-  if(b->header1)_ogg_free(b->header1);
-  b->header1=_ogg_malloc(oggpack_bytes(&opb));
-  memcpy(b->header1,opb.buffer,oggpack_bytes(&opb));
-  op_comm->packet=b->header1;
-  op_comm->bytes=oggpack_bytes(&opb);
-  op_comm->b_o_s=0;
-  op_comm->e_o_s=0;
-  op_comm->granulepos=0;
-  op_comm->packetno=1;
+  {
+    long size,padding;
+    size=oggpack_bytes(&opb);
+
+    /* leave 4096 +- 2048 bytes of padding, and
+     * make the packet size a multiple of 4096 */
+    padding=((size+0x1800)&~0xfff)-size;
+
+    if(b->header1)_ogg_free(b->header1);
+    b->header1=_ogg_malloc(size+padding);
+    memcpy(b->header1,opb.buffer,size);
+    memset(b->header1+size,0,padding);
+    op_comm->packet=b->header1;
+    op_comm->bytes=size+padding;
+    op_comm->b_o_s=0;
+    op_comm->e_o_s=0;
+    op_comm->granulepos=0;
+    op_comm->packetno=1;
+  }
 
   /* third header packet (modes/codebooks) ****************************/
 
